geos::operation::geounion::CascadedPolygonUnion Class Reference

Provides an efficient method of unioning a collection of polygonal geometries. More...

`#include <CascadedPolygonUnion.h>`

## Public Member Functions

| CascadedPolygonUnion (std::vector< geom::Polygon * > *polys)
| Creates a new instance to union the given collection of Geometrys.
| CascadedPolygonUnion (std::vector< geom::Polygon * > *polys, UnionStrategy *unionFun)
std::unique_ptr< geom::Geometry > | Union ()
| Computes the union of the input geometries.

## Static Public Member Functions

static std::unique_ptr< geom::Geometry > | Union (std::vector< geom::Polygon * > *polys)
| Computes the union of a collection of polygonal Geometrys.
static std::unique_ptr< geom::Geometry > | Union (std::vector< geom::Polygon * > *polys, UnionStrategy *unionFun)
template<class T>
static std::unique_ptr< geom::Geometry > | Union (T start, T end, UnionStrategy *unionStrategy)
| Computes the union of a set of polygonal Geometrys.
static std::unique_ptr< geom::Geometry > | Union (const geom::MultiPolygon *polys)
| Computes the union of a collection of polygonal Geometrys.

## Detailed Description

Provides an efficient method of unioning a collection of polygonal geometries.

This algorithm is faster and likely more robust than the simple iterated approach of repeatedly unioning each polygon to a result geometry.

The buffer(0) trick is sometimes faster, but can be less robust and can sometimes take an exceptionally long time to complete. This is particularly the case where there is a high degree of overlap between the polygons. In this case, buffer(0) is forced to compute with all line segments from the outset, whereas cascading can eliminate many segments at each stage of processing. The best case for buffer(0) is the trivial case where there is no overlap between the input geometries. However, this case is likely rare in practice.

## Constructor & Destructor Documentation

## CascadedPolygonUnion()

geos::operation::geounion::CascadedPolygonUnion::CascadedPolygonUnion | ( | std::vector< geom::Polygon * > * | polys | ) |

inline

Creates a new instance to union the given collection of Geometrys.

Parameters

  polys | a collection of polygonal Geometrys. Ownership of elements and vector are left to caller.

## Member Function Documentation

## Union() [1/4]

std::unique_ptr< geom::Geometry > geos::operation::geounion::CascadedPolygonUnion::Union | ( |  | ) |

Computes the union of the input geometries.

Returns
  the union of the input geometries
  null if no input geometries were provided

## Union() [2/4]

std::unique_ptr< geom::Geometry > geos::operation::geounion::CascadedPolygonUnion::Union | ( | const geom::MultiPolygon * | polys | ) |

static

Computes the union of a collection of polygonal Geometrys.

Parameters

  polys | a collection of polygonal Geometrys. Ownership of elements and vector are left to caller.

## Union() [3/4]

std::unique_ptr< geom::Geometry > geos::operation::geounion::CascadedPolygonUnion::Union | ( | std::vector< geom::Polygon * > * | polys | ) |

static

Computes the union of a collection of polygonal Geometrys.

Parameters

  polys | a collection of polygonal Geometrys. ownership of elements and vector are left to caller.

References Union().

Referenced by Union(), and Union().

## Union() [4/4]

template<class T>

std::unique_ptr< geom::Geometry > geos::operation::geounion::CascadedPolygonUnion::Union | ( | T | start,
|  | T | end,
|  | UnionStrategy * | unionStrategy )

inline static

Computes the union of a set of polygonal Geometrys.

Template Parameters

  T | an iterator yielding something castable to const Polygon *

Parameters

  start | start iterator
  end | end iterator
  unionStrategy | strategy to apply

References Union().

The documentation for this class was generated from the following file:

- CascadedPolygonUnion.h